// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //

#include <algorithm>
#include <cassert>
#include <cstddef> // IWYU pragma: keep
#include <cstdlib>
#include <filesystem>
#include <iterator>
#include <map>
#include <string>
#include <utility>
#include <vector>

#include "Utilities/Filesystem/Behaviour.hpp"
#include "Utilities/Filesystem/Directory.hpp"

#define BOOST_TEST_MODULE ensight_medit_mesh
#include "Utilities/String/String.hpp"

#include "ThirdParty/IncludeWithoutWarning/Boost/Test.hpp"

#include "Geometry/Mesh/Internal/MeshManager.hpp"
#include "Geometry/Mesh/Mesh.hpp"

#include "Test/Tools/Fixture/TestEnvironment.hpp"

using namespace MoReFEM;


PRAGMA_DIAGNOSTIC(push)
#ifdef __clang__
#include "Utilities/Warnings/Internal/IgnoreWarning/disabled-macro-expansion.hpp"
#endif // #__clang__


BOOST_FIXTURE_TEST_CASE(medit_to_ensight, TestNS::FixtureNS::TestEnvironment)
{
    decltype(auto) mesh_manager = Internal::MeshNS::MeshManager::CreateOrGetInstance();
    decltype(auto) environment = Utilities::Environment::CreateOrGetInstance();

    constexpr auto medit_unique_id = MeshNS::unique_id{ 1UL };
    constexpr auto dimension = ::MoReFEM::GeometryNS::dimension_type{ 3 };
    constexpr auto space_unit = ::MoReFEM::CoordsNS::space_unit_type{ 1. };

    std::filesystem::path path{ "${MOREFEM_ROOT}/Data/Mesh/Bar.mesh" };
    const FilesystemNS::File mesh_file{ std::move(path) };

    mesh_manager.Create(medit_unique_id, mesh_file, dimension, MeshNS::Format::Medit, space_unit);

    decltype(auto) medit_mesh = mesh_manager.GetMesh(medit_unique_id);

    const std::filesystem::path directory_path{ environment.SubstituteValues("${MOREFEM_TEST_OUTPUT_DIR}") };

    // Circumvent the fact Directory can't create non mpi directories - with good reasons!
    std::filesystem::create_directories(directory_path);

    const FilesystemNS::Directory directory(directory_path, FilesystemNS::behaviour::ignore);

    BOOST_CHECK(directory.DoExist());

    const auto ensight_mesh_file = directory.AddFile("Bar.geo");
    medit_mesh.Write<MeshNS::Format::Ensight>(ensight_mesh_file);

    constexpr auto ensight_unique_id = MeshNS::unique_id{ 2UL };
    mesh_manager.Create(ensight_unique_id, ensight_mesh_file, dimension, MeshNS::Format::Ensight, space_unit);

    decltype(auto) ensight_mesh = mesh_manager.GetMesh(ensight_unique_id);

    decltype(auto) medit_mesh_label_list = medit_mesh.GetLabelList();
    decltype(auto) ensight_mesh_label_list = ensight_mesh.GetLabelList();

    // It is possible that some labels are there only for Coords; in this case they are not reported in Ensight
    // (maybe #1378 will change that!)
    BOOST_TEST(medit_mesh_label_list.size() >= ensight_mesh_label_list.size());

    std::vector<MeshLabelNS::index_type> medit_mesh_label_index_list;
    medit_mesh_label_index_list.reserve(medit_mesh_label_list.size());

    std::ranges::transform(medit_mesh_label_list,

                           std::back_inserter(medit_mesh_label_index_list),
                           [](const auto& ptr)
                           {
                               assert(!(!ptr));
                               return ptr->GetIndex();
                           });

    assert(medit_mesh_label_index_list.size() == medit_mesh_label_list.size());


    // For Ensight things are more complicated: the format imposes labels runs from 1 to NLABEL.
    // Here we would rather get the same than for Medit, to be able to compare.
    // So I will extract the identifier from the description: when an Ensight file is generated by MoReFEM,
    // its description is MeshLabel I where I is the original mesh label.
    // Key: Ensight mesh label, from 1 to NLABEL.
    // Value: The original Medit label.
    std::map<MeshLabelNS::index_type, MeshLabelNS::index_type> ensight_mesh_label_mapping;

    for (const auto& ensight_mesh_label_ptr : ensight_mesh_label_list)
    {
        assert(!(!ensight_mesh_label_ptr));
        auto desc = ensight_mesh_label_ptr->GetDescription();
        Utilities::String::Replace("MeshLabel_", "", desc);

        auto equivalent_medit_mesh_label_id = MeshLabelNS::index_type{ static_cast<std::size_t>(stoi(desc)) };

        [[maybe_unused]] const auto check =
            ensight_mesh_label_mapping.insert({ ensight_mesh_label_ptr->GetIndex(), equivalent_medit_mesh_label_id });
        assert(check.second);

        BOOST_CHECK(std::ranges::find(medit_mesh_label_index_list,

                                      equivalent_medit_mesh_label_id)
                    != medit_mesh_label_index_list.cend());
    }

    auto ensight_bag = ensight_mesh.BagOfEltType<RoleOnProcessorPlusBoth::processor_wise>();
    auto medit_bag = medit_mesh.BagOfEltType<RoleOnProcessorPlusBoth::processor_wise>();

    BOOST_REQUIRE(ensight_bag.size() == medit_bag.size());

    std::ranges::sort(ensight_bag,

                      [](const auto& lhs, const auto& rhs)
                      {
                          assert(!(!lhs));
                          assert(!(!rhs));
                          return lhs->GetIdentifier() < rhs->GetIdentifier();
                      });

    std::ranges::sort(medit_bag,

                      [](const auto& lhs, const auto& rhs)
                      {
                          assert(!(!lhs));
                          assert(!(!rhs));
                          return lhs->GetIdentifier() < rhs->GetIdentifier();
                      });

    BOOST_REQUIRE(ensight_bag == medit_bag);

    for (const auto& [ensight_mesh_label, medit_mesh_label] : ensight_mesh_label_mapping)
    {
        for (const auto& ref_geom_elt_ptr : ensight_bag)
        {
            assert(!(!ref_geom_elt_ptr));
            const auto& ref_geom_elt = *ref_geom_elt_ptr;

            auto medit_range =
                medit_mesh.GetSubsetGeometricEltList<RoleOnProcessor::processor_wise>(ref_geom_elt, medit_mesh_label);

            auto ensight_range = ensight_mesh.GetSubsetGeometricEltList<RoleOnProcessor::processor_wise>(
                ref_geom_elt, ensight_mesh_label);

            BOOST_TEST_INFO("RefGeomElt = " << ref_geom_elt.GetName());
            BOOST_TEST_INFO("(Medit) Mesh label = " << medit_mesh_label);
            BOOST_TEST_INFO("(Ensight) Mesh label = part " << ensight_mesh_label);

            BOOST_TEST((medit_range.second - medit_range.first) == (ensight_range.second - ensight_range.first));
        }
    }

    decltype(auto) medit_geom_elt_list = medit_mesh.GetGeometricEltList<RoleOnProcessor::processor_wise>();
    decltype(auto) ensight_geom_elt_list = ensight_mesh.GetGeometricEltList<RoleOnProcessor::processor_wise>();

    BOOST_REQUIRE(medit_geom_elt_list.size() == ensight_geom_elt_list.size());
}


PRAGMA_DIAGNOSTIC(pop)

// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
